using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace VC.NET
{
    public partial class InfoBox : Form
    {
        int total;
        UInt32 dwMaxMemSize;
        JHI.OKDEVTYPE[] BoardInfo = new JHI.OKDEVTYPE[20];

        JHI.okApi okDevice;

        public InfoBox()
        {
            InitializeComponent();
        }

        public void SetDevice(JHI.okApi okDev)
        {
            okDevice = okDev;
        }

        public void SetMemSize(UInt32 size)
        {
            dwMaxMemSize = size;
        }

        private void InfoBox_Load(object sender, EventArgs e)
        {
			String	str = "";
			Int64	number,blknum;
			Int64	bufbits,bufsize;
			IntPtr	lpPhys = IntPtr.Zero, lpCurrBase = IntPtr.Zero;
            IntPtr  lpLinear = IntPtr.Zero;
            
            Int64   iCurrUsedNo;
            UInt64  dwBufSize = 0;

			total = JHI.okApi.GetImageDevice(BoardInfo, IntPtr.Zero);

            iCurrUsedNo = okDevice.GetTypeCode(-4);
            if (iCurrUsedNo < 0)
				return ;

            CurrUsed.Text = "ǰʹõĿͣ" + " (No. " + iCurrUsedNo.ToString() + ") " + BoardInfo[iCurrUsedNo].szBoardName;



            CurrSerNum.Text = "S/N:" + "                   HD Ver: " + okDevice.GetTypeCode(-7).ToString("X4");


			lpPhys = JHI.okApi.GetAvailBuffer(ref lpLinear, ref dwBufSize); //total
			number = okDevice.GetBufferSize(ref lpCurrBase, ref dwBufSize); //current
			if ((lpPhys.ToInt64() > 0xffffffff) || (lpCurrBase.ToInt64() > 0xffffffff))
                BufferSize.Text = "л: " + " PHYS " + (lpPhys.ToInt64() + (lpCurrBase.ToInt64() - lpLinear.ToInt64())).ToString("X8") + "(" + lpCurrBase.ToString("X8") + "): " + (dwBufSize / (1024 * 1024)).ToString() + " MB ";
            else
                BufferSize.Text = "л: " + " PHYS " + (lpPhys.ToInt64() + (lpCurrBase.ToInt64() - lpLinear.ToInt64())).ToString("X4") + "(" + lpCurrBase.ToString("X4") + "): " + (dwBufSize / (1024 * 1024)).ToString() + " MB ";


            bufbits = main.HIWORD((uint)okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_BUFRGBFORMAT, JHI.ConstParam.GETCURRPARAM.GetHashCode())); //-1
            bufsize = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_BUFBLOCKSIZE, JHI.ConstParam.GETCURRPARAM.GetHashCode()); //-1
            number = okDevice.GetBufferSize(IntPtr.Zero, IntPtr.Zero);

            blknum = okDevice.GetMemBlock(0, 0);
            FrameSize.Text = "ǰ֡: " + (number - blknum).ToString() + "+" + blknum.ToString() + " (" + main.LOWORD((uint)bufsize).ToString() + "x" + main.HIWORD((uint)bufsize).ToString() + "x" + bufbits.ToString() + ")";

            MemorySize.Text = "ڴС: " + " " + (dwMaxMemSize / (1024 * 1024)).ToString() + " MB";
            
			//set manufacture infos
			JHI.okApi.GetProgramInfo(JHI.ProgramParam.PROGRAM, ref str); //name
            Program.Text = str;

			JHI.okApi.GetProgramInfo(JHI.ProgramParam.VERSION, ref str); //version
            CopyRightVersion.Text = "Copyright 1999-2022   Ver. " + str;

			JHI.okApi.GetProgramInfo(JHI.ProgramParam.DRIVERDATA, ref str); //CREATEDATE
            DriverDate.Text = str;

            

            int hispr = 9;

            CurrUsed.Left = (Width - CurrUsed.Width) / 2;
            CurrSerNum.Left = (Width - CurrSerNum.Width) / 2;
            CurrSerNum.Top = CurrUsed.Top + CurrUsed.Height + hispr;
            BufferSize.Left = (Width - BufferSize.Width) / 2;
            BufferSize.Top = CurrSerNum.Top + CurrSerNum.Height + hispr;
            FrameSize.Left = (Width - FrameSize.Width) / 2;
            FrameSize.Top = BufferSize.Top + BufferSize.Height + hispr;
            MemorySize.Left = (Width - MemorySize.Width) / 2;
            MemorySize.Top = FrameSize.Top + FrameSize.Height + hispr;
            Program.Left = (Width - Program.Width) / 2;
            Program.Top = MemorySize.Top + MemorySize.Height + hispr;
            CopyRightVersion.Left = (Width - CopyRightVersion.Width) / 2;
            CopyRightVersion.Top = Program.Top + Program.Height + hispr;
            DriverDate.Left = (Width - DriverDate.Width) / 2;
            DriverDate.Top = CopyRightVersion.Top + CopyRightVersion.Height + hispr;
            Support.Left = (Width - Support.Width) / 2;
            Support.Top = DriverDate.Top + DriverDate.Height + hispr;
            Company.Left = (Width - Company.Width) / 2;
            Company.Top = Support.Top + Support.Height + hispr;
            TelFax.Left = (Width - TelFax.Width) / 2;
            TelFax.Top = Company.Top + Company.Height + hispr;
            WebMail.Left = (Width - WebMail.Width) / 2;
            WebMail.Top = TelFax.Top + TelFax.Height + hispr;

            btnOK.Left = (Width - btnOK.Width) / 2;

        }

        private void InfoBox_Shown(object sender, EventArgs e)
        {
            
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}